/*

*/

#ifndef DownCodeH
#define DownCodeH

#include <iostream>
using namespace std;
#include <string>

#include "Person.h"
#include "Allele.h"
#include "DownCodeTable.h"
#include "Map.h"

class DownCode {

   private:

      char* PedigreeFile;
      char* LocusFile;
      char* ModelFile;
      char* MapFile;

      char* OutputPedigreeFile;
      char* OutputLocusFile;
      char* OutputSolarFrequencyFile;
      char* OutputDownCodeFrequencyFile;

      string PedFileFormat;
      string Program;
      string Frequency;
      bool trait;
      bool xlinked;
      bool liab;

      int number_of_markers;

      vector<Person *> individuals;

      vector<vector<Allele> > allele_freqs_all;
      vector<vector<Allele> > allele_freqs_founders;
      vector<vector<DownCodeTable> > downcode_table_all;
      vector<vector<DownCodeTable> > downcode_table_founders;

      vector<Map> map;

      vector<string> missing_allele;
      void initializeMissingAlleleVector();
      bool isMissingAllele(string);
      string getNewMarkerAlleleCode(int,string);

      void sortAlleleVector(vector<Allele> &);

   public:

      DownCode();
      bool ParseCommandLineArguments(int,char **);
      void initializeStuff();
      bool ReadPedigreeFile();
      bool ReadMapFile();
      void CountAlleles();
      void EstimateAlleleFrequencies();
      bool CompareAlleleFrequencies();
      void CreateDowncodeTable();
      void SortDowncodeTable();
      bool WritePedigreeFile();
      bool WriteFrequenciesLinkageLocusFile();
      bool WriteLinkageLocusFile();
      bool WriteSolarFrequencyFile();
      string getProgram();

      void PrintPedigrees();
      void PrintAlleleCounts();
      void PrintAlleleFrequencies();
      void PrintDowncodeTable();
      bool WriteFrequencyandDownCodeTable();

};

#endif
