/*
  Title     : Person.h
  Version   : 1.0
  Copyright : 2004 Tero Hiekkalinna
  Author    : Tero Hiekkalinna (tero.hiekkalinna@helsinki.fi)
  Date      : 4.2.2004
*/


#if !defined(PERSON_H)
   #define PERSON_H

#include <string>
using namespace std;
#include <vector>


#include "Genotype.h"

class Person
{
   private:

      // person information: familyid, personid, etc ...
      string   familyid;
      string   personid;
      string   fatherid;
      string   motherid;
      string   sex;

      // LINKAGE specific columns
      string   first_offspring;
      string   next_paternal_sibling;
      string   next_maternal_sibling;
      string   proband_status;

      // trait
      string   affection_status;
      string   liability_class;

      bool istrait;
      bool isliab;

      vector<Genotype> genotype;

      string PedFileFormat;

   public:

      Person();
      Person(string,string,string,string,string);
      Person(string,string,string,string,string,string);
      Person(string,string,string,string,string,string,string);

      void setFirstOffspring(string);
      void setNextPaternalSibling(string);
      void setNextMaternalSibling(string);
      void setProbandStatus(string);

      void setAffectionStatus(string);
      void setLiabilityClass(string);

      void setPedFileFormat(string);

      string getFamilyID();
      string getPersonID();
      string getFatherID();
      string getMotherID();
      string getSex();
      string getAffectionStatus();
      string getLiabilityClass();

      void insertGenotype(string,string);
      string getMarkerAllele(int,int);

      string getInString();
      string getInStringALL();
      string getInString(bool);

};

#endif
