/*
  Title     : Genotype.cpp
  Version   : 1.0
  Copyright : 2004 Tero Hiekkalinna
  Author    : Tero Hiekkalinna (tero.hiekkalinna@helsinki.fi)
  Date      : 4.2.2004

  58161-5 Tietorakenteiden Harjoitusty, kevt 2004
  Helsingin yliopisto, Tietojenksittelytieteen laitos
  Ohjaaja: Olaf Laczak
*/

#include <string>
using namespace std;

#include "Genotype.h"

// Constructors
Genotype::Genotype(){}

Genotype::Genotype(string allele_1, string allele_2)
{
   this->allele[0] = allele_1;
   this->allele[1] = allele_2;
   this->next = NULL;
}

// set next genotype
void Genotype::setNext(Genotype *gt)
{
   this->next = gt;
}

// return next genotype from linked list
Genotype* Genotype::getNext()
{
   return this->next;
}

// return string presentation from genotype
string Genotype::get()
{
   return  (this->allele[0] + " " + this->allele[1]);
}

// return string presentation from genotype in Solar format
string Genotype::getSolarGenotype()
{
   return (this->allele[0] + "/" + this->allele[1]);
}
