/*
  Title     : Pedigree.h
  Version   : 1.0
  Copyright : 2004 Tero Hiekkalinna
  Author    : Tero Hiekkalinna (tero.hiekkalinna@helsinki.fi)
  Date      : 4.2.2004

  58161-5 Tietorakenteiden Harjoitusty, kevt 2004
  Helsingin yliopisto, Tietojenksittelytieteen laitos
  Ohjaaja: Olaf Laczak
*/

#if !defined(PEDIGREE_H)
   #define PEDIGREE_H

#include "Person.h"
#include "PedConvert.h"

class Pedigree
{
   private:

      // Red-black Tree root
      Person   *root;
      int      pedigree_size;

      string   ped_string;

      // Red-Black Tree variables
      string   key;     // Family ID
      string   color;
      Pedigree *left;
      Pedigree *right;
      Pedigree *parent;

      // This is only for testing linked list structure
      Pedigree *next;

      // Methods for Person Red-Black Tree
      bool RBInsert(Person *);
      void RBInsertFixup(Person *);
      void LeftRotate(Person *);
      void RightRotate(Person *);
      void RBprint(Person *, string);

      void size(Person *);

   public:

      Pedigree();
      Pedigree(string);
      Pedigree(string,string);

      // Red-Black Tree methods for Pedigree
      string getKey();
      void setLeft(Pedigree *);
      void setRight(Pedigree *);
      void setParent(Pedigree *);
      void setRED();
      void setBLACK();
      string getColor();
      Pedigree* getLeft();
      Pedigree* getRight();
      Pedigree* getParent();
      bool isNIL();

      bool insert(Person *);
      Person* find(string);
      int size();
      void print();

      string getInString();
      void getInString(Person *);

      string getInSolarString();
      void getInSolarString(Person *);

      string getMarkersInSolarString();
      void getMarkersInSolarString(Person *);

      string getPhenotypesInSolarString();
      void getPhenotypesInSolarString(Person *);

      // This is only for testing linked list structure
      void setNext(Pedigree *);
      Pedigree* getNext();
};

#endif
