/*
  Title     : Utils.cpp
  Version   : 1.0
  Copyright : 2004 Tero Hiekkalinna
  Author    : Tero Hiekkalinna (tero.hiekkalinna@helsinki.fi)
  Date      : 4.2.2004

  58161-5 Tietorakenteiden Harjoitusty, kevt 2004
  Helsingin yliopisto, Tietojenksittelytieteen laitos
  Ohjaaja: Olaf Laczak
*/

#include <iostream>
using namespace std;
#include <sstream>
#include <cmath>

#include "Utils.h"

#define NEPER 2.718218285

/*

 These methods are only used for testing PedConvert()

*/

// converts int to string
string IntToString(int value)
{
  ostringstream stringStream;
  stringStream << value << flush;
  return(stringStream.str());
}

// returns random number between 1 and max
int myRandom(int max){

   static bool first_time = true;

   // Seed the random number generator with the current time
   // of day if we haven't done so yet.
   //
   if(first_time)
   {
      first_time = false;
      srand((unsigned int)time(NULL));
   }

   return (int) rand() % max;
}

double HaldaneCentiMorganToRecombinationFraction(double cm)
{
   return (0.5 - 0.5 * pow(NEPER,(-2.0*(cm/100.0))));
}

double KosambiCentiMorganToRecombinationFraction(double cm)
{
   return 0.5 * ((pow(NEPER,(4.0*(cm/100.0))) - 1.0) / (pow(NEPER,(4.0*(cm/100.0))) + 1.0));
}
